{Utiliser lazarus-ccr-svn-r8172-components-tvplanit pour disposer de "Overlay event" }
unit demoMain;

{$mode objfpc}{$H+}

interface

uses
 {$IFDEF UNIX}
  clocale,
 {$ENDIF}
  Classes, SysUtils, FileUtil,
  Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, LCLTranslator, Menus,
  BufDataset, SQLDB, SQLite3Conn,
  LCLVersion, CheckLst,
  VpBaseDS, VpDayView, VpResEditDlg, VpNavBar, VpData, VpBase, VpSQLite3DS;

const
  DBFILENAME = 'data.db';
type

  { TMainForm }

  TMainForm = class(TForm)
    BtnDeleteRes: TButton;
    BtnEditRes: TButton;
    BtnNewRes: TButton;
    CbGranularity: TComboBox;
    CheckBox1: TCheckBox;
    lblOtherResources: TLabel;
    lblResources: TLabel;
    LblGranularity: TLabel;
    LblVisibleDays: TLabel;
    lbOtherResources: TCheckListBox;
    Notebook: TNotebook;
    Events: TPage;
    Panel2: TPanel;
    Splitter2: TSplitter;
    Panel1: TPanel;
    LeftPanel: TPanel;
    DaySelectorPanel: TPanel;
    Splitter3: TSplitter;
    DaysTrackBar: TTrackBar;
    SQLite3Connection1: TSQLite3Connection;
    SQLTransaction1: TSQLTransaction;
    VpControlLink: TVpControlLink;
    VpDayView: TVpDayView;
    VpResourceCombo: TVpResourceCombo;
    VpResourceEditDialog1: TVpResourceEditDialog;
    VpSqlite3Datastore: TVpSqlite3Datastore;
    procedure BtnDeleteResClick(Sender: TObject);
    procedure BtnNewResClick(Sender: TObject);
    procedure BtnEditResClick(Sender: TObject);
    procedure CbGranularityChange(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure DaysTrackBarChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbOtherResourcesClickCheck(Sender: TObject);
  private
    { private declarations }
    procedure ResourceChangeHandler(Sender: TObject; AResource: TVpResource);
  public
    { public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

{$UNDEF UTF8_CALLS}
{$IFDEF LCL}
  {$DEFINE UTF8_CALLS}
  {$IF (lcl_major=1) and (lcl_minor<=6)}
     {$UNDEF UTF8_CALLS}
  {$ENDIF}
{$ENDIF}

{$DEFINE NEW_ICONS}   // The same as in vp.inc

uses
  LResources, LazFileUtils, LazUTF8,DateUtils,
 {$IFNDEF UTF8_CALLS}
  lConvEncoding,
 {$ENDIF}
  ExVpRptSetup  ;

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);
begin
  try
    SQLite3Connection1.DatabaseName := AppendPathDelim(Application.Location) + DBFILENAME;
    VpSqlite3Datastore.Connected := true;

    if (VpControlLink.Datastore.Resources.Count > 0) then
        VpControlLink.Datastore.Resource := VpControlLink.Datastore.Resources.Items[0] ;

    VpControlLink.Datastore.OnResourceChange := @ResourceChangeHandler;
    //Indispensable pour permettre d'afficher la liste des resources disponibles
    ResourceChangeHandler(self,VpControlLink.Datastore.Resource);

    CheckBox1.Checked:=true;
    VpDayView.AllowDragAndDrop:=CheckBox1.Checked;
    VpDayView.AllowInplaceEditing:=self.CheckBox1.Checked;
  except
    on E:Exception do
    begin
      MessageDlg('sqlite3.dll not found. Copy it to the exe folder and restart the program.',
        mtError, [mbOK], 0);
      Close;
    end;
  end;
end;

procedure TMainForm.BtnDeleteResClick(Sender: TObject);
var
  aRes: TVpResource;
begin
  aRes := VpControlLink.Datastore.Resource;
  if aRes = nil then
    exit;
  if MessageDlg(Format('Do you really want to delete resource %s?', [aRes.Description]),
                mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    VpControlLink.Datastore.PurgeResource(aRes);
end;

procedure TMainForm.BtnEditResClick(Sender: TObject);
begin
  VpResourceEditDialog1.Execute;
end;

procedure TMainForm.BtnNewResClick(Sender: TObject);
begin
  VpResourceEditDialog1.AddNewResource;
end;

procedure TMainForm.CbGranularityChange(Sender: TObject);
begin
  VpDayView.Granularity := TVpGranularity(CbGranularity.ItemIndex);
end;

procedure TMainForm.CheckBox1Click(Sender: TObject);
var
  b : boolean;
begin
  b := checkbox1.Checked;
  VpDayView.AllowDragAndDrop:=b;
  VpDayView.DragDropTransparent:=b;
end;

procedure TMainForm.DaysTrackBarChange(Sender: TObject);
begin
  VpDayView.NumDays :=  DaysTrackBar.Position;
end;

procedure TMainForm.lbOtherResourcesClickCheck(Sender: TObject);
var
  i, n: Integer;
  aResArray: TVpResourceArray;
begin
  SetLength(aResArray, lbOtherResources.Items.Count);
  n := 0;
  for i := 0 to lbOtherResources.Items.Count-1 do
    if lbOtherResources.Checked[i] then
    begin
      aResArray[n] := TVpResource(lbOtherResources.Items.Objects[i]);
      inc(n);
    end;
  SetLength(aResArray, n);
  VpControlLink.DataStore.Resource.OverlayResources(aResArray);
end;

procedure TMainForm.ResourceChangeHandler(Sender: TObject; AResource: TVpResource);
var
  aRes: TVpResource;
  i, j: Integer;
begin
  lbOtherResources.Clear;
  for i := 0 to VpControlLink.DataStore.Resources.Count-1 do
  begin
    aRes := VpControlLink.Datastore.Resources.Items[i];
    if aRes <> AResource then
    begin
      j := lbOtherResources.Items.AddObject(aRes.Description, aRes);
      if AResource.Group <> nil then
        lbOtherResources.Checked[j] := AResource.Group.IndexOfID(AResource.ResourceID) <> -1;
    end;
  end;
end;

end.

